/*
 * Xmmsfind - A small plugin similar to the built-in "Jump to file" util. 
 * Copyright (C) 2001 Isak Savo <iso01001@student.mdh.se>
 * 
 * This program is free software; you can redistribute it and/or modify it 
 * under the terms of the GNU General Public Licensse as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.  This program is distributed in the hope
 * that it will be useful, but WITHOUT ANY WARRANTY; without even the
 * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.  You
 * should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc., 
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
 */

#include <stdio.h>
#include <stdlib.h>
#include <limits.h>
#include <glib.h>
#include <xmms/xmmsctrl.h>


#define SEARCH_CMD "search"

/*
 * Get the sessionnumber that xmms is running at. (Checks all sessions
 * ranging from 0 to 16) ("Borrowed" from Alexandre David's
 * <adavid@docs.uu.se> xmms-ctrl plugin. Thanx man!) 
 */
gint get_xmms_session ()
{
    gint query;
    
    for (query = 0; query < 16; query++)
      if (xmms_remote_is_running (query))
	return query;
    return -1;
}


/* Opens the fifo locate in ~/.xmms/ and writes the searchcommand to it
 * the xmmsfind general plugin will then launch the searchbox */
int main (void)
{
    FILE *fifo;
    char fifo_path[_POSIX_PATH_MAX];

    if (!xmms_remote_is_running (get_xmms_session ()))
    {
	printf ("Xmms not running\n");
	return 0;
    }
    snprintf (fifo_path, _POSIX_PATH_MAX, "%s/.xmms/xmmsfind_fifo", getenv ("HOME"));
    if ((fifo = fopen (fifo_path, "w")) == NULL)
    {
	fprintf (stderr, "Unable to open fifo '%s'\nAborting\n", fifo_path);
	return 0;
    }
    fputs (SEARCH_CMD, fifo);
    return 0;
}
